<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/
namespace App\Validators\Admin;
use Illuminate\Support\Facades\Validator;
use App\Managers\Position\PositionManager;
use App\Managers\PositionColumns\PositionColumnsManager;

class AdminPositionValidator
{
    public function __construct()
    {
        $this->position = new PositionManager();
        $this->positionColumns = new PositionColumnsManager();
    }
    public function add($data, $columns)
    {
        $validation = $validator = Validator::make(
                ['Name'             => trim($data['name']),
                 'Short Form'       => trim($data['short_form'])],
                ['Name'             => 'required',
                 'Short Form'       => 'required|max:10']
        );
        if ($validation->fails())
        {
            $errors = $validation->errors();
            $errors = $errors->toArray();
            
            foreach($errors AS $error)
            {
                $return['errors'][] = $error;
            }
            return $return;
        }
        
        $team = $this->position->where('name', $data['name'])->where('deleted_at', NULL)->first();
        if($team)
        {
            $return['errors'][] = 'Name is already registered with our database';
            return $return;
            exit;
        }
        
        if(empty($columns))
        {
            $return['errors'][] = 'No columns selected';
            return $return;
            exit;
        }
        else
        {
            foreach($columns AS $key => $value)
            {
                $res = $this->positionColumns->where('column_count', $value)->where('deleted_at', NULL)->where('inactive', 0)->first();
                if($res)
                {
                    $return['errors'][] = 'Column ' . $value . ' already selected for another position';
                }
            }
            if(isset($return))
            {
                return $return;
            }
        }
                
                
    }
    
    public function update($data, $columns, $UUID)
    {
        $validation = $validator = Validator::make(
                ['Name'             => trim($data['name'])],
                ['Name'             => 'required']
        );
        if ($validation->fails())
        {
            $errors = $validation->errors();
            $errors = $errors->toArray();
            
            foreach($errors AS $error)
            {
                $return['errors'][] = $error;
            }
            return $return;
        }
        
        $team = $this->position->where('name', $data['name'])->where('UUID', '!=', $UUID)->where('deleted_at', NULL)->first();
        if($team)
        {
            $return['errors'][] = 'Name is already registered with our database';
            return $return;
            exit;
        }
        
        
        if(empty($columns))
        {
            $return['errors'][] = 'No columns selected';
            return $return;
            exit;
        }
        else
        {
            foreach($columns AS $key => $value)
            {
                $res = $this->positionColumns->where('column_count', $value)->where('position_id', '!=', $UUID)->where('deleted_at', NULL)->where('inactive', 0)->first();
                if($res)
                {
                    $return['errors'][] = 'Column ' . $value . ' already selected for another position';
                }
            }
            if(isset($return))
            {
                return $return;
            }
        }
    }
}