<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class AddColumnsToProposalTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('proposal', function (Blueprint $table) {
            $table->text('proposal')->nullable()->after('UUID');
            $table->text('video')->nullable()->after('proposal');
            $table->text('admin_response')->nullable()->after('video');
            $table->boolean('confirm')->default(0)->after('admin_response');
            $table->boolean('reject')->default(0)->after('confirm');
            $table->bigInteger('no_of_likes')->default(0)->after('reject');
            $table->uuid('user_id')->after('no_of_likes');
            
            
            $table->foreign('user_id')->references('UUID')->on('users');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('proposal', function (Blueprint $table) {
            //
        });
    }
}
